diff -uwbBpr libfloat/softfloat/bits64/386-Win32-gcc/milieu.h SoftFloat-2a/softfloat/bits64/386-Win32-gcc/milieu.h
--- libfloat/softfloat/bits64/386-Win32-gcc/milieu.h	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/386-Win32-gcc/milieu.h	Mon Sep 20 11:47:12 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C header file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the Web page `http://http.cs.berkeley.edu/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
diff -uwbBpr libfloat/softfloat/bits64/386-Win32-gcc/softfloat-specialize SoftFloat-2a/softfloat/bits64/386-Win32-gcc/softfloat-specialize
--- libfloat/softfloat/bits64/386-Win32-gcc/softfloat-specialize	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/386-Win32-gcc/softfloat-specialize	Mon Sep 20 11:47:12 1999
@@ -1,31 +1,29 @@
 
-/*** CHECK COMMENTS ***/
-
 /*
 ===============================================================================
 
 This C source fragment is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 1a.
+Arithmetic Package, Release 2a.
 
-Written by John R. Hauser.  This work was made possible by the International
-Computer Science Institute, located at Suite 600, 1947 Center Street,
-Berkeley, California 94704.  Funding was provided in part by the National
-Science Foundation under grant MIP-9311980.  The original version of
-this code was written as part of a project to build a fixed-point vector
+Written by John R. Hauser.  This work was made possible in part by the
+International Computer Science Institute, located at Suite 600, 1947 Center
+Street, Berkeley, California 94704.  Funding was partially provided by the
+National Science Foundation under grant MIP-9311980.  The original version
+of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the web page `http://www.cs.berkeley.edu/~jhauser/
-softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
-THIS PACKAGE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort has
-been made to avoid it, THIS PACKAGE MAY CONTAIN FAULTS THAT WILL AT TIMES
-RESULT IN INCORRECT BEHAVIOR.  USE OF THIS PACKAGE IS RESTRICTED TO PERSONS
-AND ORGANIZATIONS WHO CAN AND WILL TAKE FULL RESPONSIBILITY FOR ANY AND ALL
-LOSSES, COSTS, OR OTHER PROBLEMS ARISING FROM ITS USE.
+THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
+has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
+TIMES RESULT IN INCORRECT BEHAVIOR.  USE OF THIS SOFTWARE IS RESTRICTED TO
+PERSONS AND ORGANIZATIONS WHO CAN AND WILL TAKE FULL RESPONSIBILITY FOR ANY
+AND ALL LOSSES, COSTS, OR OTHER PROBLEMS ARISING FROM ITS USE.
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -33,8 +31,8 @@ this code that are retained.
 
 /*
 -------------------------------------------------------------------------------
-Underflow tininess-detection mode.  (Statically initialized to default
-value.  The declaration in `softfloat.h' must match the `int8' type here.)
+Underflow tininess-detection mode, statically initialized to default value.
+(The declaration in `softfloat.h' must match the `int8' type here.)
 -------------------------------------------------------------------------------
 */
 int8 float_detect_tininess = float_tininess_after_rounding;
@@ -42,8 +40,8 @@ int8 float_detect_tininess = float_tinin
 /*
 -------------------------------------------------------------------------------
 Raises the exceptions specified by `flags'.  Floating-point traps can be
-defined here if desired.  It is currently not possible for such a trap to
-substitute a result value.  If traps are not implemented, this routine
+defined here if desired.  It is currently not possible for such a trap
+to substitute a result value.  If traps are not implemented, this routine
 should be simply `float_exception_flags |= flags;'.
 -------------------------------------------------------------------------------
 */
@@ -56,6 +54,7 @@ void float_raise( int8 flags )
 
 /*
 -------------------------------------------------------------------------------
+Internal canonical NaN format.
 -------------------------------------------------------------------------------
 */
 typedef struct {
@@ -72,6 +71,8 @@ The pattern for a default generated sing
 
 /*
 -------------------------------------------------------------------------------
+Returns 1 if the single-precision floating-point value `a' is a NaN;
+otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float32_is_nan( float32 a )
@@ -83,8 +84,8 @@ flag float32_is_nan( float32 a )
 
 /*
 -------------------------------------------------------------------------------
-Returns true if the single-precision floating-point value `a' is a signaling
-NaN; otherwise returns false.
+Returns 1 if the single-precision floating-point value `a' is a signaling
+NaN; otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float32_is_signaling_nan( float32 a )
@@ -96,6 +97,9 @@ flag float32_is_signaling_nan( float32 a
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the single-precision floating-point NaN
+`a' to the canonical NaN format.  If `a' is a signaling NaN, the invalid
+exception is raised.
 -------------------------------------------------------------------------------
 */
 static commonNaNT float32ToCommonNaN( float32 a )
@@ -112,6 +116,8 @@ static commonNaNT float32ToCommonNaN( fl
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the canonical NaN `a' to the single-
+precision floating-point format.
 -------------------------------------------------------------------------------
 */
 static float32 commonNaNToFloat32( commonNaNT a )
@@ -165,6 +171,8 @@ The pattern for a default generated doub
 
 /*
 -------------------------------------------------------------------------------
+Returns 1 if the double-precision floating-point value `a' is a NaN;
+otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float64_is_nan( float64 a )
@@ -176,8 +184,8 @@ flag float64_is_nan( float64 a )
 
 /*
 -------------------------------------------------------------------------------
-Returns true if the double-precision floating-point value `a' is a signaling
-NaN; otherwise returns false.
+Returns 1 if the double-precision floating-point value `a' is a signaling
+NaN; otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float64_is_signaling_nan( float64 a )
@@ -191,6 +199,9 @@ flag float64_is_signaling_nan( float64 a
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the double-precision floating-point NaN
+`a' to the canonical NaN format.  If `a' is a signaling NaN, the invalid
+exception is raised.
 -------------------------------------------------------------------------------
 */
 static commonNaNT float64ToCommonNaN( float64 a )
@@ -207,6 +218,8 @@ static commonNaNT float64ToCommonNaN( fl
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the canonical NaN `a' to the double-
+precision floating-point format.
 -------------------------------------------------------------------------------
 */
 static float64 commonNaNToFloat64( commonNaNT a )
@@ -268,6 +281,8 @@ respectively.
 
 /*
 -------------------------------------------------------------------------------
+Returns 1 if the extended double-precision floating-point value `a' is a
+NaN; otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag floatx80_is_nan( floatx80 a )
@@ -279,8 +294,8 @@ flag floatx80_is_nan( floatx80 a )
 
 /*
 -------------------------------------------------------------------------------
-Returns true if the extended double-precision floating-point value `a' is a
-signaling NaN; otherwise returns false.
+Returns 1 if the extended double-precision floating-point value `a' is a
+signaling NaN; otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag floatx80_is_signaling_nan( floatx80 a )
@@ -297,6 +312,9 @@ flag floatx80_is_signaling_nan( floatx80
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the extended double-precision floating-
+point NaN `a' to the canonical NaN format.  If `a' is a signaling NaN, the
+invalid exception is raised.
 -------------------------------------------------------------------------------
 */
 static commonNaNT floatx80ToCommonNaN( floatx80 a )
@@ -313,6 +331,8 @@ static commonNaNT floatx80ToCommonNaN( f
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the canonical NaN `a' to the extended
+double-precision floating-point format.
 -------------------------------------------------------------------------------
 */
 static floatx80 commonNaNToFloatx80( commonNaNT a )
@@ -375,6 +395,8 @@ The pattern for a default generated quad
 
 /*
 -------------------------------------------------------------------------------
+Returns 1 if the quadruple-precision floating-point value `a' is a NaN;
+otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float128_is_nan( float128 a )
@@ -388,8 +410,8 @@ flag float128_is_nan( float128 a )
 
 /*
 -------------------------------------------------------------------------------
-Returns true if the quadruple-precision floating-point value `a' is a
-signaling NaN; otherwise returns false.
+Returns 1 if the quadruple-precision floating-point value `a' is a
+signaling NaN; otherwise returns 0.
 -------------------------------------------------------------------------------
 */
 flag float128_is_signaling_nan( float128 a )
@@ -403,6 +425,9 @@ flag float128_is_signaling_nan( float128
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the quadruple-precision floating-point NaN
+`a' to the canonical NaN format.  If `a' is a signaling NaN, the invalid
+exception is raised.
 -------------------------------------------------------------------------------
 */
 static commonNaNT float128ToCommonNaN( float128 a )
@@ -418,6 +443,8 @@ static commonNaNT float128ToCommonNaN( f
 
 /*
 -------------------------------------------------------------------------------
+Returns the result of converting the canonical NaN `a' to the quadruple-
+precision floating-point format.
 -------------------------------------------------------------------------------
 */
 static float128 commonNaNToFloat128( commonNaNT a )
diff -uwbBpr libfloat/softfloat/bits64/386-Win32-gcc/softfloat.h SoftFloat-2a/softfloat/bits64/386-Win32-gcc/softfloat.h
--- libfloat/softfloat/bits64/386-Win32-gcc/softfloat.h	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/386-Win32-gcc/softfloat.h	Mon Sep 20 11:47:13 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C header file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the Web page `http://http.cs.berkeley.edu/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -119,6 +119,14 @@ floatx80 int32_to_floatx80( int );
 #ifdef FLOAT128
 float128 int32_to_float128( int );
 #endif
+float32 int64_to_float32( long long );
+float64 int64_to_float64( long long );
+#ifdef FLOATX80
+floatx80 int64_to_floatx80( long long );
+#endif
+#ifdef FLOAT128
+float128 int64_to_float128( long long );
+#endif
 
 /*
 -------------------------------------------------------------------------------
@@ -127,6 +135,8 @@ Software IEC/IEEE single-precision conve
 */
 int float32_to_int32( float32 );
 int float32_to_int32_round_to_zero( float32 );
+long long float32_to_int64( float32 );
+long long float32_to_int64_round_to_zero( float32 );
 float64 float32_to_float64( float32 );
 #ifdef FLOATX80
 floatx80 float32_to_floatx80( float32 );
@@ -162,6 +172,8 @@ Software IEC/IEEE double-precision conve
 */
 int float64_to_int32( float64 );
 int float64_to_int32_round_to_zero( float64 );
+long long float64_to_int64( float64 );
+long long float64_to_int64_round_to_zero( float64 );
 float32 float64_to_float32( float64 );
 #ifdef FLOATX80
 floatx80 float64_to_floatx80( float64 );
@@ -199,6 +211,8 @@ Software IEC/IEEE extended double-precis
 */
 int floatx80_to_int32( floatx80 );
 int floatx80_to_int32_round_to_zero( floatx80 );
+long long floatx80_to_int64( floatx80 );
+long long floatx80_to_int64_round_to_zero( floatx80 );
 float32 floatx80_to_float32( floatx80 );
 float64 floatx80_to_float64( floatx80 );
 #ifdef FLOAT128
@@ -244,6 +258,8 @@ Software IEC/IEEE quadruple-precision co
 */
 int float128_to_int32( float128 );
 int float128_to_int32_round_to_zero( float128 );
+long long float128_to_int64( float128 );
+long long float128_to_int64_round_to_zero( float128 );
 float32 float128_to_float32( float128 );
 float64 float128_to_float64( float128 );
 #ifdef FLOATX80
Only in libfloat/softfloat/bits64: ARM-gcc
Only in libfloat/softfloat/bits64: CVS
Only in libfloat/softfloat/bits64/SPARC-Solaris-gcc: CVS
diff -uwbBpr libfloat/softfloat/bits64/SPARC-Solaris-gcc/Makefile SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/Makefile
--- libfloat/softfloat/bits64/SPARC-Solaris-gcc/Makefile	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/Makefile	Mon Sep 20 12:14:00 1999
@@ -1,25 +1,24 @@
 
-PROCESSOR_DIR = ../../../processors
-PROCESSOR_H = $(PROCESSOR_DIR)/SPARC-gcc.h
+PROCESSOR_H = ../../../processors/SPARC-gcc.h
 SOFTFLOAT_MACROS = ../softfloat-macros
-CC = gcc
-CINCLUDES = -I. -I.. -I-
-CFLAGS = -O2
-LINK = gcc
-LFLAGS =
-TIMESOFTFLOAT_EXE = timesoftfloat
 
-ALL: softfloat.o $(TIMESOFTFLOAT_EXE)
+OBJ = .o
+EXE =
+INCLUDES = -I. -I..
+COMPILE_C = gcc -c -o $@ $(INCLUDES) -I- -O2
+LINK = gcc -o $@
+
+ALL: softfloat$(OBJ) timesoftfloat$(EXE)
 
 milieu.h: $(PROCESSOR_H)
 	touch milieu.h
 
-softfloat.o: milieu.h softfloat.h softfloat-specialize $(SOFTFLOAT_MACROS) ../softfloat.c
-	$(CC) $(CINCLUDES) $(CFLAGS) -c ../softfloat.c
+softfloat$(OBJ): milieu.h softfloat.h softfloat-specialize $(SOFTFLOAT_MACROS) ../softfloat.c
+	$(COMPILE_C) ../softfloat.c
 
-timesoftfloat.o: milieu.h softfloat.h ../timesoftfloat.c
-	$(CC) $(CINCLUDES) $(CFLAGS) -c ../timesoftfloat.c
+timesoftfloat$(OBJ): milieu.h softfloat.h ../timesoftfloat.c
+	$(COMPILE_C) ../timesoftfloat.c
 
-$(TIMESOFTFLOAT_EXE): softfloat.o timesoftfloat.o
-	$(LINK) $(LFLAGS) -o $(TIMESOFTFLOAT_EXE) softfloat.o timesoftfloat.o
+timesoftfloat$(EXE): softfloat$(OBJ) timesoftfloat$(OBJ)
+	$(LINK) softfloat$(OBJ) timesoftfloat$(OBJ)
 
diff -uwbBpr libfloat/softfloat/bits64/SPARC-Solaris-gcc/milieu.h SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/milieu.h
--- libfloat/softfloat/bits64/SPARC-Solaris-gcc/milieu.h	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/milieu.h	Mon Sep 20 12:14:05 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C header file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the Web page `http://http.cs.berkeley.edu/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
diff -uwbBpr libfloat/softfloat/bits64/SPARC-Solaris-gcc/softfloat-specialize SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/softfloat-specialize
--- libfloat/softfloat/bits64/SPARC-Solaris-gcc/softfloat-specialize	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/softfloat-specialize	Mon Sep 20 12:14:11 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C source fragment is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the Web page `http://http.cs.berkeley.edu/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -40,8 +40,8 @@ int8 float_detect_tininess = float_tinin
 /*
 -------------------------------------------------------------------------------
 Raises the exceptions specified by `flags'.  Floating-point traps can be
-defined here if desired.  It is currently not possible for such a trap to
-substitute a result value.  If traps are not implemented, this routine
+defined here if desired.  It is currently not possible for such a trap
+to substitute a result value.  If traps are not implemented, this routine
 should be simply `float_exception_flags |= flags;'.
 -------------------------------------------------------------------------------
 */
diff -uwbBpr libfloat/softfloat/bits64/SPARC-Solaris-gcc/softfloat.h SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/softfloat.h
--- libfloat/softfloat/bits64/SPARC-Solaris-gcc/softfloat.h	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/SPARC-Solaris-gcc/softfloat.h	Mon Sep 20 12:14:15 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C header file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -13,7 +13,7 @@ of this code was written as part of a pr
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
 is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
-arithmetic/softfloat.html'.
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -119,6 +119,14 @@ floatx80 int32_to_floatx80( int );
 #ifdef FLOAT128
 float128 int32_to_float128( int );
 #endif
+float32 int64_to_float32( long long );
+float64 int64_to_float64( long long );
+#ifdef FLOATX80
+floatx80 int64_to_floatx80( long long );
+#endif
+#ifdef FLOAT128
+float128 int64_to_float128( long long );
+#endif
 
 /*
 -------------------------------------------------------------------------------
@@ -127,6 +135,8 @@ Software IEC/IEEE single-precision conve
 */
 int float32_to_int32( float32 );
 int float32_to_int32_round_to_zero( float32 );
+long long float32_to_int64( float32 );
+long long float32_to_int64_round_to_zero( float32 );
 float64 float32_to_float64( float32 );
 #ifdef FLOATX80
 floatx80 float32_to_floatx80( float32 );
@@ -162,6 +172,8 @@ Software IEC/IEEE double-precision conve
 */
 int float64_to_int32( float64 );
 int float64_to_int32_round_to_zero( float64 );
+long long float64_to_int64( float64 );
+long long float64_to_int64_round_to_zero( float64 );
 float32 float64_to_float32( float64 );
 #ifdef FLOATX80
 floatx80 float64_to_floatx80( float64 );
@@ -199,6 +211,8 @@ Software IEC/IEEE extended double-precis
 */
 int floatx80_to_int32( floatx80 );
 int floatx80_to_int32_round_to_zero( floatx80 );
+long long floatx80_to_int64( floatx80 );
+long long floatx80_to_int64_round_to_zero( floatx80 );
 float32 floatx80_to_float32( floatx80 );
 float64 floatx80_to_float64( floatx80 );
 #ifdef FLOAT128
@@ -244,6 +258,8 @@ Software IEC/IEEE quadruple-precision co
 */
 int float128_to_int32( float128 );
 int float128_to_int32_round_to_zero( float128 );
+long long float128_to_int64( float128 );
+long long float128_to_int64_round_to_zero( float128 );
 float32 float128_to_float32( float128 );
 float64 float128_to_float64( float128 );
 #ifdef FLOATX80
diff -uwbBpr libfloat/softfloat/bits64/softfloat-macros SoftFloat-2a/softfloat/bits64/softfloat-macros
--- libfloat/softfloat/bits64/softfloat-macros	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/softfloat-macros	Mon Sep 20 11:47:07 1999
@@ -3,7 +3,7 @@
 ===============================================================================
 
 This C source fragment is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -169,8 +169,8 @@ Shifts the 128-bit value formed by conca
 number of bits given in `count'.  If any nonzero bits are shifted off, they
 are ``jammed'' into the least significant bit of the result by setting the
 least significant bit to 1.  The value of `count' can be arbitrarily large;
-in particular, if `count' is greater than 128, the result will be either 0
-or 1, depending on whether the concatenation of `a0' and `a1' is zero or
+in particular, if `count' is greater than 128, the result will be either
+0 or 1, depending on whether the concatenation of `a0' and `a1' is zero or
 nonzero.  The result is broken into two 64-bit pieces which are stored at
 the locations pointed to by `z0Ptr' and `z1Ptr'.
 -------------------------------------------------------------------------------
@@ -483,9 +483,9 @@ INLINE void mul64To128( bits64 a, bits64
 
 /*
 -------------------------------------------------------------------------------
-Multiplies the 128-bit value formed by concatenating `a0' and `a1' by `b' to
-obtain a 192-bit product.  The product is broken into three 64-bit pieces
-which are stored at the locations pointed to by `z0Ptr', `z1Ptr', and
+Multiplies the 128-bit value formed by concatenating `a0' and `a1' by
+`b' to obtain a 192-bit product.  The product is broken into three 64-bit
+pieces which are stored at the locations pointed to by `z0Ptr', `z1Ptr', and
 `z2Ptr'.
 -------------------------------------------------------------------------------
 */
@@ -622,8 +622,8 @@ static bits32 estimateSqrt32( int16 aExp
 
 /*
 -------------------------------------------------------------------------------
-Returns the number of leading 0 bits before the most-significant 1 bit
-of `a'.  If `a' is zero, 32 is returned.
+Returns the number of leading 0 bits before the most-significant 1 bit of
+`a'.  If `a' is zero, 32 is returned.
 -------------------------------------------------------------------------------
 */
 static int8 countLeadingZeros32( bits32 a )
@@ -664,8 +664,8 @@ static int8 countLeadingZeros32( bits32 
 
 /*
 -------------------------------------------------------------------------------
-Returns the number of leading 0 bits before the most-significant 1 bit
-of `a'.  If `a' is zero, 64 is returned.
+Returns the number of leading 0 bits before the most-significant 1 bit of
+`a'.  If `a' is zero, 64 is returned.
 -------------------------------------------------------------------------------
 */
 static int8 countLeadingZeros64( bits64 a )
